View Issue Details

IDProjectCategoryView StatusLast Update
0001401FreeCADBugpublic2017-03-27 17:26
Reporterpeterl94Assigned Towmayer 
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
PlatformOSMac OS XOS Version10.6
Product Version 
Target VersionFixed in Version0.17 
Summary0001401: Problem w/ MDI windows on OSX (AKA transition from QGLWidget to QOpenGLWidget )
DescriptionThere is a couple problems with the MDI windows on Mac OS X, which I think are caused by the same bug. Firstly, the 3d view windows show up in non 3d windows (start, drawing macro editor, etc.). If you click on one of the windows, it switches to its tab. Secondly, if you tile or cascade the windows, the drawing order is not correct. See attached images.
Steps To ReproduceCreate a new document, and switch to a non 3d view (e.g. the start page)
TagsCocoa, MacOSX, QOpenGLWidget, Qt5, upstream

Relationships

related to 0002868 new Port QtWebKit to QtWebKitEngine 
child of 0002986 confirmed Port from Qt4 to Qt5 (Ongoing) 

Activities

peterl94

2014-02-10 21:46

developer  

3dviews_in_non_3dwindows.png (Attachment missing)

peterl94

2014-02-10 21:48

developer  

wrong_draw_order.png (Attachment missing)

peterl94

2014-02-10 21:51

developer   ~0004180

Oh, I should add that the Qt MDI example works fine.

wmayer

2014-02-11 10:20

administrator   ~0004184

To me this seems more an OpenGL issue.

peterl94

2014-02-11 19:20

developer   ~0004187

Hmm, yeah, that's probable.

peterl94

2014-02-13 19:15

developer   ~0004217

Turns out this a know problem with Qt on Mac, but it doesn't seem to be fixable due to a limitation in the Cocoa API. https://bugreports.qt-project.org/browse/QTBUG-8647

Kunda1

2017-01-09 22:43

manager   ~0007593

According to the upstream Qt bug (https://bugreports.qt.io/browse/QTBUG-8647) this has been solved in Qt5.4
Any OSX testers able to confirm this?

Kunda1

2017-01-10 12:34

manager   ~0007596

@peter94 Can you confirm this is fixed based on ~7593 ?

Kunda1

2017-01-10 15:37

manager   ~0007606

Per @triplus (in http://forum.freecadweb.org/viewtopic.php?f=10&p=152647#p152647)
> I researched this when working on PieMenu and if i remember correctly transition from QGLWidget to QOpenGLWidget will need to be made to resolve this issue properly. It won't resolve itself by just using Qt5 build as we still use QGLWidget.

Kunda1

2017-01-19 13:22

manager   ~0007876

renamed issue for more comprehension

ian.rees

2017-02-03 22:43

developer   ~0008198

Last edited: 2017-02-04 00:44

View 4 revisions

When this is resolved, the changes made in bd28c52fca7f7b1335fb5f27d232a42264b31c2d should be amended.

Kunda1

2017-02-04 00:46

manager   ~0008200

Last edited: 2017-03-07 02:39

View 3 revisions

Testing markup:
c:FreeCAD:bd28c52fca7f7b1335fb5f27d232a42264b31c2d:

blacey

2017-03-06 23:39

developer   ~0008556

Last edited: 2017-03-06 23:39

View 2 revisions

Werner recently [url=https://forum.freecadweb.org/viewtopic.php?f=10&t=19724&start=10#p152622]asked[/url] if Qt 5 resolved this issue. Further to @peterl94's comment, Qt 5 alone will not but porting to QGLWidget to QOpenGLWidget should. Mateusz shared an early-stage, narrowly-focused, proof-of-concept qopenglwidget branch (i.e. no where near ready for prime time) that I can confirm will resolve this long-standing issue cleanly.

blacey

2017-03-09 15:13

developer   ~0008591

Werner's recent qtopengl branch resolves this issue as well as Mateusz' proof-of-concept branch. We can safely assume that one the QtOpenGLWidget branch is merged into master, the issue will be resolved.

Issue History

Date Modified Username Field Change
2014-02-10 21:46 peterl94 New Issue
2014-02-10 21:46 peterl94 File Added: 3dviews_in_non_3dwindows.png
2014-02-10 21:48 peterl94 File Added: wrong_draw_order.png
2014-02-10 21:51 peterl94 Note Added: 0004180
2014-02-11 10:20 wmayer Note Added: 0004184
2014-02-11 19:20 peterl94 Note Added: 0004187
2014-02-13 19:15 peterl94 Note Added: 0004217
2014-02-13 22:35 shoogen Relationship added related to 0001408
2014-02-13 22:36 shoogen Tag Attached: Cocoa
2014-02-13 22:38 shoogen Relationship deleted related to 0001408
2015-01-06 23:22 wmayer Status new => confirmed
2017-01-09 17:19 Kunda1 Tag Attached: upstream
2017-01-09 22:43 Kunda1 Note Added: 0007593
2017-01-10 11:59 Kunda1 Tag Attached: #tobeclosed
2017-01-10 12:34 Kunda1 Note Added: 0007596
2017-01-10 15:36 Kunda1 Tag Detached: #tobeclosed
2017-01-10 15:37 Kunda1 Note Added: 0007606
2017-01-15 15:54 Kunda1 Tag Attached: QOpenGLWidget
2017-01-19 13:02 Kunda1 Tag Attached: MacOSX
2017-01-19 13:22 Kunda1 Note Added: 0007876
2017-01-19 13:22 Kunda1 Summary Problem with MDI windows on Mac OS X => Problem w/ MDI windows on OSX (AKA transition from QGLWidget to QOpenGLWidget )
2017-01-19 13:23 Kunda1 Tag Attached: Qt5
2017-01-21 21:06 Kunda1 Relationship added related to 0002868
2017-02-03 22:43 ian.rees Note Added: 0008198
2017-02-04 00:44 Kunda1 Note Edited: 0008198 View Revisions
2017-02-04 00:44 Kunda1 Note Edited: 0008198 View Revisions
2017-02-04 00:44 Kunda1 Note Edited: 0008198 View Revisions
2017-02-04 00:46 Kunda1 Note Added: 0008200
2017-02-04 00:47 Kunda1 Note Edited: 0008200 View Revisions
2017-03-06 23:39 blacey Note Added: 0008556
2017-03-06 23:39 blacey Note Edited: 0008556 View Revisions
2017-03-07 02:39 Kunda1 Note Edited: 0008200 View Revisions
2017-03-09 15:13 blacey Note Added: 0008591
2017-03-21 19:44 wmayer Changeset attached => FreeCAD master c193dbe2
2017-03-21 19:48 wmayer Assigned To => wmayer
2017-03-21 19:48 wmayer Status confirmed => closed
2017-03-21 19:48 wmayer Resolution open => fixed
2017-03-21 19:48 wmayer Fixed in Version => 0.17
2017-03-27 17:26 Kunda1 Relationship added child of 0002986